/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { ShapeItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { BrushScale } from "igniteui-webcomponents-charts";
import { enumGetBox, runOn, delegateCombine, delegateRemove, markType, markDep } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
export let GeographicShapeSeriesBase = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBase extends GeographicMapSeriesHost {
        constructor() {
            super(...arguments);
            this.xj = false;
            this.xi = false;
            this.assigningShapeStyle = null;
            this.assigningShapeMarkerStyle = null;
            this.xf = null;
            this.xh = false;
        }
        ct() {
            return new GeographicShapeSeriesBaseView(this);
        }
        q1(a) {
            super.q1(a);
            this.xe = a;
        }
        get_fe() {
            return true;
        }
        get_ee() {
            return true;
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.xe.cm();
                    break;
                case "ShapeMemberPath":
                    this.xe.co();
                    break;
                case GeographicShapeSeriesBase.$$p[8]:
                    this.xe.cn();
                    break;
                case GeographicShapeSeriesBase.$$p[4]:
                    this.w2.ya = this.xm;
                    this.xj = this.xm;
                    if (this.xm) {
                        let e = this.w2;
                        e.assigningShapeStyle = delegateCombine(e.assigningShapeStyle, runOn(this, this.x4));
                    }
                    else {
                        let f = this.w2;
                        f.assigningShapeStyle = delegateRemove(f.assigningShapeStyle, runOn(this, this.x4));
                    }
                    break;
                case GeographicShapeSeriesBase.$$p[3]:
                    this.w2.x9 = this.xl;
                    this.xi = this.xl;
                    if (this.xm) {
                        let g = this.w2;
                        g.assigningShapeMarkerStyle = delegateCombine(g.assigningShapeMarkerStyle, runOn(this, this.x3));
                    }
                    else {
                        let h = this.w2;
                        h.assigningShapeMarkerStyle = delegateRemove(h.assigningShapeMarkerStyle, runOn(this, this.x3));
                    }
                    break;
                case GeographicShapeSeriesBase.$$p[5]:
                    this.w2.xm = this.xd;
                    break;
                case GeographicShapeSeriesBase.$$p[6]:
                    this.w2.yr = this.xo;
                    break;
                case GeographicShapeSeriesBase.$$p[7]:
                    this.w2.ys = this.xp;
                    break;
                case GeographicShapeSeriesBase.$$p[0]:
                    this.w2.yw = this.xq;
                    break;
                case GeographicShapeSeriesBase.$$p[1]:
                    this.w2.xc = this.xc;
                    break;
                case GeographicShapeSeriesBase.$$p[2]:
                    this.w2.x5 = this.xk;
                    break;
                case "ShapefileDataSource":
                    if (c != null) {
                        let i = c;
                        if (this.xh) {
                            i.importCompleted = delegateRemove(i.importCompleted, runOn(this, this.x5));
                        }
                    }
                    if (d != null) {
                        let j = d;
                        if (j.count > 0) {
                            this.x6();
                            break;
                        }
                        this.xh = true;
                        j.importCompleted = delegateCombine(j.importCompleted, runOn(this, this.x5));
                    }
                    break;
            }
        }
        x4(a, b) {
            if (this.assigningShapeStyle != null) {
                this.assigningShapeStyle(this, b);
            }
        }
        x3(a, b) {
            if (this.assigningShapeMarkerStyle != null) {
                this.assigningShapeMarkerStyle(this, b);
            }
        }
        x5(a, b) {
            this.x6();
        }
        x6() {
            let sds_ = this.xg;
            let ext_ = sds_.externalObject;
            this.itemsSource = (ext_.getPointData());
        }
        get xg() {
            return this.xf;
        }
        set xg(a) {
            let b = this.xf;
            this.xf = a;
            if (b != this.xf) {
                this.raisePropertyChanged("ShapefileDataSource", b, this.xf);
            }
        }
        get_g7() {
            return true;
        }
        set_g7(a) {
            super.set_g7(a);
        }
    }
    GeographicShapeSeriesBase.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBase, 'GeographicShapeSeriesBase', GeographicMapSeriesHost.$);
    GeographicShapeSeriesBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeriesBase, 'raisePropertyChanged', ['FillMemberPath:xq:x7', [2], 'FillScale:xc:x8', [BrushScale.$], 'FillScaleUseGlobalValues:xk:x9', [0, false], 'IsCustomShapeMarkerStyleAllowed:xl:ya', [0, false], 'IsCustomShapeStyleAllowed:xm:yb', [0, false], 'ItemSearchMode:xd:yc', [ShapeItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:xo:yd', [1, 10000], 'ItemSearchThreshold:xp:ye', [1, 10000], 'ShapeFilterResolution:xn:yf', [1, 2], 'ShapeMemberPath:x1:yg', [2, "points"]]);
    return GeographicShapeSeriesBase;
})();
/**
 * @hidden
 */
export let GeographicShapeSeriesBaseView = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cl = null;
            this.cl = a;
        }
        b9() {
            super.b9();
            this.cl.w2.y9 = this.cl.x1;
        }
        cm() {
            let a = this.cl.w2;
            if (this.cl.dc == null) {
                a.xg = null;
                a.xi = null;
                return;
            }
            a.xg = this.cl.dc.wv;
            a.xi = this.cl.dc.wx;
        }
        co() {
            this.cl.w2.y9 = this.cl.x1;
        }
        cn() {
            this.cl.w2.yo = this.cl.xn;
        }
    }
    GeographicShapeSeriesBaseView.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseView, 'GeographicShapeSeriesBaseView', HostSeriesView.$);
    return GeographicShapeSeriesBaseView;
})();
