/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SeriesViewer } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { MapResizeBehavior_$type } from "./MapResizeBehavior";
import { MapBackgroundTilingMode_$type } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-webcomponents-core";
import { Base, Boolean_$type, typeCast, enumGetBox, Point_$type, fromEnum, Number_$type, runOn, delegateRemove, delegateCombine, markType, markDep, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, IEnumerable_$type } from "igniteui-webcomponents-core";
import { NumericXAxis } from "igniteui-webcomponents-charts";
import { NumericYAxis } from "igniteui-webcomponents-charts";
import { SphericalMercatorVerticalScaler } from "./SphericalMercatorVerticalScaler";
import { Control } from "igniteui-webcomponents-core";
import { SphericalMercatorHorizontalScaler } from "./SphericalMercatorHorizontalScaler";
import { ScalerParams } from "igniteui-webcomponents-charts";
import { SeriesViewerView } from "igniteui-webcomponents-charts";
import { Tuple$2 } from "igniteui-webcomponents-core";
import { MathUtil } from "igniteui-webcomponents-core";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { ItfConverter } from "igniteui-webcomponents-core";
import { ChartVisualData } from "igniteui-webcomponents-charts";
import { RectData } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-webcomponents-core";
import { XamMultiScaleImage } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ScatterAreaSeries } from "igniteui-webcomponents-charts";
import { BrushCollection } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { OpenStreetMapTileSource } from "igniteui-webcomponents-core";
import { ColorScale } from "igniteui-webcomponents-charts";
/**
 * @hidden
 */
export let XamGeographicMap = /*@__PURE__*/ (() => {
    class XamGeographicMap extends SeriesViewer {
        constructor() {
            super();
            this.xk = null;
            this.w9 = false;
            this.w1 = 1;
            this.xg = 0;
            this.yr = null;
            this.wy = null;
            this.wu = null;
            this.ww = null;
            this.w0 = null;
            this.yn = { $type: Point_$type, x: NaN, y: NaN };
            this.yu = null;
            this.xf = 1;
            this.imageTilesReady = null;
            this.w8 = null;
            this.yt = Rect.empty;
            this.xg = SphericalMercatorVerticalScaler.am(XamGeographicMap.ys.bottom) - SphericalMercatorVerticalScaler.am(XamGeographicMap.ys.top);
            this.ab = XamGeographicMap.$;
            this.backgroundContent = new OpenStreetMapImagery();
            let a = ((() => {
                let $ret = new NumericXAxis();
                $ret.bi = this;
                return $ret;
            })());
            a.cf = true;
            this.wv = a;
            this.wv.n4 = new SphericalMercatorHorizontalScaler();
            let b = ((() => {
                let $ret = new NumericYAxis();
                $ret.bi = this;
                return $ret;
            })());
            b.cf = true;
            this.wx = b;
            this.wx.n4 = new SphericalMercatorVerticalScaler();
            this.x2();
            this.x9();
            this.n1();
        }
        provideContainer(a) {
            super.provideContainer(a);
            this.wv.provideRenderer(a);
            this.wx.provideRenderer(a);
        }
        n1() {
            super.n1();
            this.w7.fv(this.hj);
        }
        fk() {
            return this.xd;
        }
        fl() {
            return this.xd;
        }
        w4() {
            if (this.w2 == 0) {
                if (this.w9) {
                    return 2;
                }
            }
            return 1;
        }
        get w3() {
            return this.w1;
        }
        set w3(a) {
            this.w1 = a;
        }
        get yw() {
            return this.yr;
        }
        set yw(a) {
            let b = Rect.l_op_Inequality(this.yr, a);
            if (b) {
                let c = this.yr;
                this.yr = a;
                this.qn("ActualWorldRect", c, a);
            }
        }
        y0() {
            return this.yw;
        }
        x2() {
            if (this.y8.isEmpty) {
                return;
            }
            this.yw = this.y6(this.y8, this.cr == 1);
        }
        y6(a, b) {
            let c = a.top;
            let d = a.left;
            let e = a.width;
            let f = a.height;
            let g = SphericalMercatorVerticalScaler.am(a.bottom);
            let h = SphericalMercatorVerticalScaler.am(a.top);
            let i = g - h;
            let j = a.width / XamGeographicMap.ys.width;
            let k = SphericalMercatorVerticalScaler.am(XamGeographicMap.ys.top);
            let l = i / j;
            if (i / j > this.xg) {
                let m = i / this.xg;
                let n = m - j;
                d = d - (n / 2) * XamGeographicMap.ys.width;
                e = m * XamGeographicMap.ys.width;
                if (b) {
                    if (d < XamGeographicMap.ys.left) {
                        d += (XamGeographicMap.ys.left - d);
                    }
                    else if ((d + e) > XamGeographicMap.ys.right) {
                        d -= ((d + e) - XamGeographicMap.ys.right);
                    }
                }
            }
            else if (i / j < this.xg) {
                let o = this.xg * j;
                let p = o - i;
                let q = h - (p / 2);
                let r = g + (p / 2);
                if (b) {
                    if (q < k) {
                        q += (k - q);
                        r += (k - q);
                    }
                    else if (r > (k + this.xg)) {
                        q -= ((r) - (k + this.xg));
                        r -= ((r) - (k + this.xg));
                    }
                }
                c = SphericalMercatorVerticalScaler.aq(q);
                f = SphericalMercatorVerticalScaler.aq(r) - c;
            }
            let s = new Rect(0, d, c, e, f);
            return s;
        }
        get backgroundContent() {
            return this.wy;
        }
        set backgroundContent(a) {
            let b = a != this.backgroundContent;
            if (b) {
                let c = this.backgroundContent;
                this.wy = a;
                this.qn("BackgroundContent", c, a);
            }
        }
        get wv() {
            return this.wu;
        }
        set wv(a) {
            let b = a != this.wv;
            if (b) {
                let c = this.wv;
                this.wu = a;
                this.qn("XAxis", c, a);
            }
        }
        get wx() {
            return this.ww;
        }
        set wx(a) {
            let b = a != this.wx;
            if (b) {
                let c = this.wx;
                this.ww = a;
                this.qn("YAxis", c, a);
            }
        }
        getZoomRectFromGeoRect(a) {
            return this.getZoomFromGeographicRect(a);
        }
        yc(a) {
            this.wo = a;
        }
        yb(a) {
            this.y8 = a;
        }
        getZoomFromGeographicRect(a) {
            return this.yy(a, true, 0);
        }
        yx(a, b) {
            return this.yy(a, false, b);
        }
        yy(a, b, c) {
            let d = a;
            if (b) {
                d = this.y6(a, false);
            }
            let e = this.wv;
            let f = this.wx;
            let g = new ScalerParams(1, XamGeographicMap.yv, this.wn, e.ch);
            g.c = this.v9;
            let h = new ScalerParams(1, XamGeographicMap.yv, this.wn, f.ch);
            h.c = this.v9;
            let i = this.wv.el(d.left, g);
            let j = this.wv.el(d.right, g);
            let k = this.wx.el(d.top, h);
            let l = this.wx.el(d.bottom, h);
            let m = (i - c) / this.wn.width;
            let n = (l - c) / this.wn.height;
            let o = (j - i + (c * 2)) / this.wn.width;
            let p = (k - l + (c * 2)) / this.wn.height;
            let q = new Rect(0, m, n, o, p);
            q.intersect(XamGeographicMap.yv);
            if (q.isEmpty) {
                q = XamGeographicMap.yv;
            }
            return q;
        }
        getZoomFromGeographicPoints(a, b) {
            let c = a.x;
            let d = b.y;
            let e = b.x - a.x;
            let f = a.y - b.y;
            if (e < 0 || f < 0) {
                return XamGeographicMap.yv;
            }
            else {
                let g = new Rect(0, c, d, e, f);
                return this.getZoomFromGeographicRect(g);
            }
        }
        y2(a) {
            let b = this.wv;
            let c = this.wx;
            let d = new ScalerParams(1, a, this.wn, b.ch);
            d.c = this.v9;
            let e = new ScalerParams(1, a, this.wn, c.ch);
            e.c = this.v9;
            let f = this.v8;
            let g = b.eo(f.left, d);
            let h = c.eo(f.top, e);
            let i = b.eo(f.right, d);
            let j = c.eo(f.bottom, e);
            let k = i - g;
            let l = h - j;
            let m = new Rect(0, g, j, k, l);
            if (this.cr == 1) {
                m.intersect(XamGeographicMap.ys);
                if (m.isEmpty) {
                    m = XamGeographicMap.ys;
                }
            }
            return m;
        }
        yo(a) {
            let b = this.wv.mf(a.x);
            let c = this.wx.mf(a.y);
            return { $type: Point_$type, x: b, y: c };
        }
        yp(a) {
            let b = this.wv.e6(a.x);
            let c = this.wx.e6(a.y);
            return { $type: Point_$type, x: b, y: c };
        }
        yq(a) {
            return this.yp(a);
        }
        xz() {
            let a = typeCast(GeographicMapImagery.$, this.backgroundContent);
            if (a != null) {
                a.clearTileCache();
            }
        }
        x5(a) {
        }
        gf() {
            return true;
        }
        x7() {
            this.w7.ee();
            for (let a of fromEnum(this.series)) {
                a.se();
            }
        }
        ya() {
            if (this.w6 == 2) {
                if (!this.wn.isEmpty && this.wn.width > 0 && this.wn.height > 0) {
                    let a = this.wv.mf(this.wn.left + (this.wn.width / 2));
                    let b = this.wx.mf(this.wn.top + (this.wn.height / 2));
                    this.yn = { $type: Point_$type, x: a, y: b };
                }
            }
            else {
                if (!this.wn.isEmpty && this.wn.width > 0 && this.wn.height > 0) {
                    let c = this.wv.mf(this.wn.left);
                    let d = this.wx.mf(this.wn.top);
                    this.yn = { $type: Point_$type, x: c, y: d };
                }
            }
        }
        x6() {
            if (isNaN_(this.yn.x) || isNaN_(this.yn.y)) {
                this.ya();
            }
            let a = this.yn.x;
            let b = this.yn.y;
            if (!isNaN_(a) && !isNaN_(b)) {
                let c = this.v5.left;
                let d = this.v5.top;
                let e = this.v5.width;
                let f = this.v5.height;
                if (e > this.yu.width) {
                }
                else {
                    let g = new ScalerParams(1, XamGeographicMap.yv, this.wn, this.wv.ch);
                    g.c = this.v9;
                    let h = this.wv.el(a, g);
                    if (this.w6 == 2) {
                        let i = h / this.wn.width;
                        c = i - (e / 2);
                    }
                    else {
                        c = h / this.wn.width;
                    }
                    if (c + e > this.yu.right) {
                        c = this.yu.right - e;
                    }
                    else if (c < this.yu.left) {
                        c = this.yu.left;
                    }
                }
                if (f > this.yu.height) {
                }
                else {
                    let j = new ScalerParams(1, XamGeographicMap.yv, this.wn, this.wx.ch);
                    j.c = this.v9;
                    let k = this.wx.el(b, j);
                    if (this.w6 == 2) {
                        let l = k / this.wn.height;
                        d = l - (f / 2);
                    }
                    else {
                        d = k / this.wn.height;
                    }
                    if (d + f > this.yu.bottom) {
                        d = this.yu.bottom - f;
                    }
                    else if (d < this.yu.top) {
                        d = this.yu.top;
                    }
                }
                this.ry(new Rect(0, c, d, e, f), false);
            }
        }
        get_fc() {
            return true;
        }
        v6() {
            let a = super.v6();
            if (this.wv == null || this.wx == null) {
                return a;
            }
            this.wh();
            let b = a.left;
            let c = a.top;
            if (this.cr == 1) {
                if (this.wo.width > this.yu.width) {
                    b = 0.5 - (this.wo.width / 2);
                }
                else if (b + a.width > this.yu.right) {
                    b = this.yu.right - this.wo.width;
                }
                else if (b < this.yu.left) {
                    b = this.yu.left;
                }
                if (this.wo.height > this.yu.height) {
                    c = 0.5 - (this.wo.height / 2);
                }
                else if (c + this.wo.height > this.yu.bottom) {
                    c = this.yu.bottom - this.wo.height;
                }
                else if (c < this.yu.top) {
                    c = this.yu.top;
                }
            }
            let d = false;
            if (!this.xc && this.cr == 2 && this.w9) {
                if (b > 1) {
                    b = (b - Math.floor(b)) + 1;
                }
                if (b < 0) {
                    b = 0 - (Math.ceil(b) - b);
                }
                if ((a.right - this.yu.right) > 0 && ((a.right - this.yu.right) / a.width) > 0.8) {
                    b = this.yu.left - (a.width - (a.right - this.yu.right));
                    d = true;
                }
                else if (a.left < this.yu.left && (Math.abs(a.left - this.yu.left) / a.width) > 0.8) {
                    b = this.yu.right - (Math.abs(a.left - this.yu.left));
                    d = true;
                }
            }
            let e = new Rect(0, b, c, a.width, a.height);
            if (this.xc) {
                let f = this.yx(this.y8, 1);
                f = this.yz(f);
                let g = e.left + e.width / 2;
                let h = e.top + e.height / 2;
                if (e.width > f.width) {
                    let i = e.height / e.width;
                    let j = f.width;
                    let k = i * j;
                    e = new Rect(0, g - j / 2, h - k / 2, j, k);
                    d = true;
                }
                if (e.height > f.height) {
                    let l = e.width / e.height;
                    let m = f.height;
                    let n = l * m;
                    e = new Rect(0, g - n / 2, h - m / 2, n, m);
                    d = true;
                }
                if (e.left < f.left) {
                    e = new Rect(0, f.left, e.top, e.width, e.height);
                    d = true;
                }
                if (e.top < f.top) {
                    e = new Rect(0, e.left, f.top, e.width, e.height);
                    d = true;
                }
                if (e.right > f.right) {
                    e = new Rect(0, f.right - e.width, e.top, e.width, e.height);
                    d = true;
                }
                if (e.bottom > f.bottom) {
                    e = new Rect(0, e.left, f.bottom - e.height, e.width, e.height);
                    d = true;
                }
            }
            if (d) {
                this.ey = true;
                this.wo = e;
                this.ey = false;
            }
            return e;
        }
        m5(a, b) {
            let c = true;
            let d = true;
            let e = 0;
            let f = this.wh();
            let g = 0;
            let h = 0;
            if ((a.right - f.right) > 0) {
                g = ((a.right - f.right) / a.width);
            }
            if (a.left < f.left) {
                h = (Math.abs(a.left - f.left) / a.width);
            }
            if (h == 0 && g == 0) {
                c = false;
            }
            if (h > g) {
                d = false;
            }
            if (c) {
                if (d) {
                    let i = this.wu.el(-180, b);
                    let j = this.wu.el(180, b);
                    e = j - i;
                }
                else {
                    let k = this.wu.el(-180, b);
                    let l = this.wu.el(180, b);
                    e = k - l;
                }
            }
            return new Tuple$2(Boolean_$type, Number_$type, c, e);
        }
        wh() {
            let a = new ScalerParams(1, XamGeographicMap.yv, this.wn, this.wv.ch);
            a.c = this.v9;
            let b = new ScalerParams(1, XamGeographicMap.yv, this.wn, this.wx.ch);
            b.c = this.v9;
            let c = this.wv.el(XamGeographicMap.ys.left, a);
            let d = this.wv.el(XamGeographicMap.ys.right, a);
            let e = this.wx.el(XamGeographicMap.ys.top, b);
            let f = this.wx.el(XamGeographicMap.ys.bottom, b);
            this.yu = new Rect(0, c / this.wn.width, f / this.wn.height, (d - c) / this.wn.width, (e - f) / this.wn.height);
            return this.yu;
        }
        yz(a) {
            let b = this.hn;
            let c = 0.5 * (a.left + a.right);
            let d = 0.5 * (a.top + a.bottom);
            let e = a.width;
            let f = a.height;
            let g = MathUtil.d(a.width, b, 1);
            let h = MathUtil.d(a.height, b, 1);
            let i = this.wn;
            let j = i.width / i.height;
            let k = g * i.width;
            let l = h * i.height;
            let m = k / l;
            if (m != j) {
                if (l * j > k) {
                    k = l * j;
                    g = k / i.width;
                }
                else {
                    l = k / j;
                    h = l / i.height;
                }
            }
            let n = g != e;
            let o = h != f;
            let p = n ? c - 0.5 * g : a.left;
            let q = o ? d - 0.5 * h : a.top;
            let r = n ? c + 0.5 * g : a.right;
            let s = o ? d + 0.5 * h : a.bottom;
            if (p < 0) {
                p = 0;
                r = p + g;
            }
            if (r > 1) {
                r = 1;
                p = r - g;
            }
            if (q < 0) {
                q = 0;
                s = q + h;
            }
            if (s > 1) {
                s = 1;
                q = s - h;
            }
            return new Rect(0, p, q, r - p, s - q);
        }
        v7(a) {
            super.v7(this.wn);
            if (a.isEmpty) {
                return Rect.empty;
            }
            let b;
            if (a.width > a.height) {
                let c = intDivide(truncate((a.width - a.height)), 2);
                b = new Rect(0, a.left + c, a.top, a.height, a.height);
            }
            else {
                let d = intDivide(truncate((a.height - a.width)), 2);
                b = new Rect(0, a.left, a.top + d, a.width, a.width);
            }
            return b;
        }
        y1(a) {
            return this.v7(a);
        }
        c8() {
            return new XamGeographicMapView(this);
        }
        x1(a) {
            if (a != null) {
                a.bi = this;
            }
        }
        p6(a) {
            super.p6(a);
            this.w7 = a;
        }
        qh(a, b) {
            super.qh(a, b);
            this.rm(this.wv);
            this.rm(this.wx);
            if (Rect.l_op_Inequality(a, b)) {
                this.x6();
            }
            if (this.xc) {
                this.v5 = this.v6();
            }
            this.yd();
        }
        get xh() {
            return this.xf;
        }
        set xh(a) {
            let b = this.xf;
            this.xf = a;
            this.qn("ActualWindowScale", b, this.xf);
        }
        ht() {
            return this.xh;
        }
        hu() {
            return this.xh;
        }
        rl() {
            super.rl();
            let a = Math.min(this.v5.width, this.v5.height);
            this.xh = a;
        }
        f3() {
            return this.w9;
        }
        cs() {
            if (this.ct == 0) {
                if (this.xa) {
                    return 2;
                }
            }
            return this.ct;
        }
        qi(a, b, c, d) {
            super.qi(a, b, c, d);
            switch (b) {
                case "ZoomCoercionMode":
                    this.x2();
                    break;
                case "WindowRect":
                    this.ya();
                    break;
                case XamGeographicMap.$$p[0]:
                    this.w3 = this.w4();
                    if (this.w0 != null) {
                        this.w0.isHorizontalWrappingEnabled = this.w3 == 2;
                    }
                    break;
                case XamGeographicMap.$$p[1]:
                    this.w9 = this.xa;
                    this.w3 = this.w4();
                    this.cr = this.cs();
                    if (this.w0 != null) {
                        this.w0.isHorizontalWrappingEnabled = this.w3 == 2;
                    }
                    break;
                case XamGeographicMap.$$p[4]:
                    this.v5 = this.v6();
                    break;
                case "BackgroundContent":
                    if (this.w0 != null) {
                        let e = this.w0;
                        e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.x3));
                        this.w0.deferralHandler = null;
                    }
                    this.w0 = typeCast(GeographicMapImagery.$, this.backgroundContent);
                    if (this.w0 != null) {
                        let f = this.w0;
                        f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.x3));
                        this.w0.deferralHandler = this;
                        this.w0.isHorizontalWrappingEnabled = this.w3 == 2;
                    }
                    this.w7.fu(typeCast(GeographicMapImagery.$, c), typeCast(GeographicMapImagery.$, d));
                    if (this.w0 != null) {
                        this.w0.geographicMap = this;
                        this.w7.fr(this.v5);
                        this.w7.fv(this.hj);
                    }
                    break;
                case "YAxis":
                case "XAxis":
                    this.x8(c);
                    this.x1(d);
                    break;
                case XamGeographicMap.$$p[6]:
                    if (!this.xb) {
                        this.wo = XamGeographicMap.yv;
                    }
                    this.x2();
                    this.x9();
                    this.ya();
                    this.v5 = this.v6();
                    this.w7.fs();
                    break;
                case "ActualWindowRect":
                    this.w7.fr(this.v5);
                    break;
                case "ActualWorldRect":
                    for (let g of fromEnum(this.series)) {
                        g.rs(false);
                    }
                    break;
                case XamGeographicMap.$$p[5]:
                    this.xh = this.xi;
                    break;
                case "ActualWindowScale":
                    if (!this.gb) {
                        this.rw(this.ht(), this.hu());
                    }
                    break;
                case "ActualPixelScalingRatio":
                    this.w7.fv(this.hj);
                    break;
                case "WindowRectMinWidth":
                case "WindowRectMinHeight":
                    let h = d;
                    if (isNaN_(h) || isInfinity(h)) {
                        this.hn = 5E-06;
                        this.hm = 5E-06;
                    }
                    else {
                        this.hn = h;
                        this.hm = h;
                    }
                    break;
                case XamGeographicMap.$$p[7]:
                    this.rs();
                    break;
                case "MarkerAutomaticBehavior":
                    for (let i of fromEnum(this.series)) {
                        i.qg();
                    }
                    break;
            }
        }
        x3(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new ImageTilesReadyEventArgs());
            }
        }
        x8(a) {
            if (a != null) {
                a.bi = null;
            }
        }
        x9() {
            if (this.wv != null) {
                this.wv.mc = this.yw.left;
                this.wv.mb = this.yw.right;
            }
            if (this.wx != null) {
                this.wx.mc = this.yw.top;
                this.wx.mb = this.yw.bottom;
            }
            this.wv.c2(true);
            this.wx.c2(true);
        }
        getFontInfo() {
            this.w8 = this.w7.fo;
            return this.w8;
        }
        u9() {
            return this.w7.fw;
        }
        getFontBrush() {
            return this.w7.fx;
        }
        re(a, b) {
            if (typeCast(ItfConverter.$, b) !== null) {
                let c = b;
                let d = a;
                d.itemsSource = c.triangulationSource.points;
                d.xb = c.triangulationSource.triangles;
            }
            else {
                super.re(a, b);
            }
        }
        register(a, b) {
            this.q2(a, b);
        }
        unRegister(a) {
            this.rk(a);
        }
        deferredRefresh() {
            this.nj();
        }
        deferAction(a) {
            if (this.xk != null) {
                this.xk.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        x0(a) {
            this.rr(a);
        }
        xl() {
            let a = new ChartVisualData();
            let b = this.wv.fy();
            let c = this.wx.fy();
            a.axes.add1(b);
            a.axes.add1(c);
            for (let d = 0; d < this.series.count; d++) {
                let e = this.series._inner[d].km();
                a.series.add1(e);
            }
            a.name = this.name;
            a.contentArea = RectData.b(this.wn);
            a.centralArea = RectData.b(this.wn);
            a.plotArea = RectData.b(this.wn);
            return a;
        }
        wd(a, b, c) {
            return a;
        }
        x4() {
        }
        get y7() {
            return this.yt;
        }
        set y7(a) {
            this.yt = a;
        }
        ye(a) {
            this.y7 = a;
            this.yd();
        }
        yd() {
            if (this.xe && !this.y7.isEmpty) {
                let a = this.getZoomFromGeographicRect(this.y7);
                this.y7 = Rect.empty;
                this.ry(a, false);
            }
        }
        get xe() {
            return !this.wn.isEmpty && !this.v9.isEmpty;
        }
    }
    XamGeographicMap.$t = /*@__PURE__*/ markType(XamGeographicMap, 'XamGeographicMap', SeriesViewer.$, [IMapRenderDeferralHandler_$type]);
    XamGeographicMap.w5 = 0;
    XamGeographicMap.ys = /*@__PURE__*/ new Rect(2, { $type: Point_$type, x: -180, y: -85.05112878 }, { $type: Point_$type, x: 180, y: 85.05112878 });
    XamGeographicMap.yv = /*@__PURE__*/ new Rect(0, 0, 0, 1, 1);
    XamGeographicMap.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, XamGeographicMap, 'qn', ['BackgroundTilingMode:w2:yf', [MapBackgroundTilingMode_$type, /*@__PURE__*/ enumGetBox(MapBackgroundTilingMode_$type, 0)], 'IsHorizontalWrappingEnabled:xa:yg', [0, false], 'ResizeBehavior:w6:yh', [MapResizeBehavior_$type, /*@__PURE__*/ enumGetBox(MapResizeBehavior_$type, XamGeographicMap.w5)], 'SuppressZoomResetOnWorldRectChange:xb:yi', [0, false], 'UseWorldRectForZoomBounds:xc:yj', [0, false], 'WindowScale:xi:yk', [1, NaN], 'WorldRect:y8:yl', [Rect.$, XamGeographicMap.ys], 'Zoomable:xd:ym', [0, true]]);
    return XamGeographicMap;
})();
/**
 * @hidden
 */
export let GeographicMapImagery = /*@__PURE__*/ (() => {
    class GeographicMapImagery extends Control {
        constructor(a) {
            super();
            this.ak = null;
            this.imageTilesReady = null;
            this.an = null;
            this.ap = null;
            this.propertyChanged = null;
            this.imagesChanged = null;
            this.cancellingImage = null;
            this.downloadingImage = null;
            this.ab = GeographicMapImagery.$;
            this.ap = a;
            this.aj = this.ai();
            this.bb(this.aj);
        }
        bb(a) {
        }
        ai() {
            return new GeographicMapImageryView(this);
        }
        get deferralHandler() {
            return this.ak;
        }
        set deferralHandler(a) {
            this.ak = a;
            if (this.ao != null) {
                this.ao.al = a;
            }
        }
        a5(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new ImageTilesReadyEventArgs());
            }
        }
        a9() {
            let a = this.ao;
            a.imageTilesReady = delegateCombine(a.imageTilesReady, runOn(this, this.a5));
            this.ao.al = this.deferralHandler;
            let b = this.ao;
            b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.a4));
            let c = this.ao;
            c.downloadingImage = delegateCombine(c.downloadingImage, runOn(this, this.a3));
            let d = this.ao;
            d.cancellingImage = delegateCombine(d.cancellingImage, runOn(this, this.a2));
            this.ao.bf = this.referer;
            this.ao.bj = this.userAgent;
            this.ao.av = this.isHorizontalWrappingEnabled;
        }
        a3(a, b) {
            if (this.downloadingImage != null) {
                this.downloadingImage(this, b);
            }
        }
        a2(a, b) {
            if (this.cancellingImage != null) {
                this.cancellingImage(this, b);
            }
        }
        bg() {
            if (this.ao != null) {
                this.aj.e();
            }
        }
        ba(a, b, c) {
            switch (a) {
                case GeographicMapImagery.$$p[3]:
                    this.bg();
                    break;
                case "GeographicMap":
                    this.aj.e();
                    break;
                case GeographicMapImagery.$$p[1]:
                    if (this.ao != null) {
                        this.ao.bf = this.referer;
                    }
                    break;
                case GeographicMapImagery.$$p[2]:
                    if (this.ao != null) {
                        this.ao.bj = this.userAgent;
                    }
                    break;
                case GeographicMapImagery.$$p[0]:
                    if (this.ao != null) {
                        this.ao.av = this.isHorizontalWrappingEnabled;
                    }
                    break;
            }
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        get geographicMap() {
            return this.c(GeographicMapImagery.geographicMapProperty);
        }
        set geographicMap(a) {
            this.h(GeographicMapImagery.geographicMapProperty, a);
        }
        static a8(a, b) {
            a.a7(b.oldValue, b.newValue);
        }
        a7(a, b) {
            this.ba("GeographicMap", a, b);
        }
        clearTileCache() {
            if (this.ao != null) {
                this.ao.bs(0, 0, 0, 0);
            }
        }
        get ao() {
            return this.an;
        }
        set ao(a) {
            this.an = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("MultiScaleImage"));
            }
        }
        bn(a) {
            if (this.geographicMap == null || a.width < 1 || a.height < 1) {
                return a;
            }
            let b = new Rect(0, 0, 0, a.width, a.height);
            let c = this.geographicMap.y1(b);
            let d = XamGeographicMap.ys;
            let e = this.geographicMap.yw;
            let f = Math.min(this.windowRect.height, this.windowRect.width);
            let g = e.width / d.width;
            this.ao.a5 = (b.width / c.width) * f * g;
            let h = this.geographicMap.wv;
            let i = this.geographicMap.wx;
            let j = new ScalerParams(1, this.windowRect, b, h.ch);
            j.c = c;
            let k = new ScalerParams(1, this.windowRect, b, i.ch);
            k.c = c;
            let l = h.el(d.left, j);
            let m = i.el(d.bottom, k);
            let n = (-l / b.width) * this.ao.a5;
            let o = (-m / b.height) * this.ao.a5 * (b.height / b.width);
            this.ao.cm = { $type: Point_$type, x: n, y: o };
            return a;
        }
        bd(a) {
            this.aj.f(a);
        }
        bf(a) {
            this.aj.h(a);
        }
        be(a) {
            this.aj.g(a);
        }
        a4(a, b) {
            if (this.imagesChanged != null) {
                this.imagesChanged(this, new ImagesChangedEventArgs());
            }
        }
        a6() {
            this.aj.e();
        }
        bc(a) {
            this.aj.i(a);
        }
        v() {
            super.v();
            this.ap.o = this._opacity;
        }
    }
    GeographicMapImagery.$t = /*@__PURE__*/ markType(GeographicMapImagery, 'GeographicMapImagery', Control.$, [INotifyPropertyChanged_$type]);
    GeographicMapImagery.geographicMapProperty = /*@__PURE__*/ DependencyProperty.i("GeographicMap", XamGeographicMap.$, GeographicMapImagery.$, /*@__PURE__*/ new PropertyMetadata(2, null, GeographicMapImagery.a8));
    GeographicMapImagery.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicMapImagery, 'ba', ['IsHorizontalWrappingEnabled', [0, false], 'Referer', [2, null], 'UserAgent', [2, null], 'WindowRect', [Rect.$, Rect.empty]]);
    return GeographicMapImagery;
})();
/**
 * @hidden
 */
export let GeographicMapImageryView = /*@__PURE__*/ (() => {
    class GeographicMapImageryView extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.j = null;
            this.d = null;
            this.b = 1;
            this.j = Rect.empty;
            this.a = a;
            this.a.ao = new XamMultiScaleImage();
            this.a.ao.ao = this.a.ap;
            this.a.a9();
        }
        e() {
            if (this.j.isEmpty) {
                return;
            }
            this.a.bn(new Size(1, this.j.width, this.j.height));
        }
        f(a) {
            this.a.ao.b1(a);
        }
        g(a) {
            this.d = a;
            this.a.ao.b2(a);
        }
        h(a) {
            this.j = a;
            this.a.ao.b3(a);
            this.a.a6();
        }
        get c() {
            return this.b;
        }
        i(a) {
            this.b = a;
            this.a.ao.bz(a);
        }
    }
    GeographicMapImageryView.$t = /*@__PURE__*/ markType(GeographicMapImageryView, 'GeographicMapImageryView');
    return GeographicMapImageryView;
})();
/**
 * @hidden
 */
export let GeographicXYTriangulatingSeriesView = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cl = null;
            this.cl = a;
        }
        b9() {
            super.b9();
            let a = this.cl.w2;
            a.x2 = this.cl.xe;
            a.ya = this.cl.xc;
            a.trianglesSource = this.cl.xb;
            a.xq = this.cl.xh;
            a.xs = this.cl.xj;
            a.xu = this.cl.xl;
        }
        co() {
            let a = this.cl.w2;
            if (this.cl.dc == null) {
                a.w0 = null;
                a.w1 = null;
                return;
            }
            a.w0 = this.cl.dc.wv;
            a.w1 = this.cl.dc.wx;
        }
        cn() {
            this.cl.w2.x2 = this.cl.xe;
        }
        cm() {
            this.cl.w2.ya = this.cl.xc;
        }
        cp() {
            this.cl.w2.trianglesSource = this.cl.xb;
        }
        cq() {
            this.cl.w2.xq = this.cl.xh;
        }
        cr() {
            this.cl.w2.xs = this.cl.xj;
        }
        cs() {
            this.cl.w2.xu = this.cl.xl;
        }
    }
    GeographicXYTriangulatingSeriesView.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesView, 'GeographicXYTriangulatingSeriesView', HostSeriesView.$);
    return GeographicXYTriangulatingSeriesView;
})();
/**
 * @hidden
 */
export let GeographicScatterAreaSeriesView = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesView extends GeographicXYTriangulatingSeriesView {
        constructor(a) {
            super(a);
            this.ct = null;
            this.ct = a;
        }
        ax() {
            super.ax();
            if (!this.r) {
            }
        }
        b9() {
            super.b9();
            if (this.ct.xw != null) {
                this.ct.xw.y9 = this.ct.x0;
                this.ct.xw.yx = this.ct.xv;
            }
        }
        cu() {
            if (this.ct.xw != null) {
                this.ct.xw.y9 = this.ct.x0;
            }
        }
        cv() {
            if (this.ct.xw != null) {
                this.ct.xw.yx = this.ct.xv;
            }
        }
    }
    GeographicScatterAreaSeriesView.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesView, 'GeographicScatterAreaSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicScatterAreaSeriesView;
})();
/**
 * @hidden
 */
export let XamGeographicMapView = /*@__PURE__*/ (() => {
    class XamGeographicMapView extends SeriesViewerView {
        constructor(a) {
            super(a);
            this.fn = null;
            this.fz = null;
            this.fx = null;
            this.fw = null;
            this.fo = null;
            this.fp = NaN;
            this.fz = Rect.empty;
            this.fn = a;
            this.fn.u2 = 2;
            this.fn.iu = 5E-06;
        }
        m(a) {
            return 2;
        }
        bk(a) {
            this.j.bw(a);
            this.fn.x0(a);
            this.el();
        }
        get_ap() {
            return true;
        }
        d4() {
            let a;
            let b;
            let c;
            let d;
            let e;
            let f = this.j.a8(a, b, c, d, e);
            a = f.p0;
            b = f.p1;
            c = f.p2;
            d = f.p3;
            e = f.p4;
            this.fx = c;
            this.fo = d;
            this.fw = e;
            let g = this.j.e();
            this.fn.ag = g.a;
            this.fn.aj = g.f;
            this.fn.ah = g.b != null ? g.b : new BrushCollection();
            this.fn.ai = g.c != null ? g.c : new BrushCollection();
            if (this.fn.ah.count == 0) {
                for (let h = 0; h < g.a.count; h++) {
                    this.fn.ah.add(g.a.item(h));
                }
            }
            if (g.c.count == 0) {
                for (let i = 0; i < g.f.count; i++) {
                    this.fn.ai.add(g.f.item(i));
                }
            }
        }
        du(a) {
            super.du(a);
            if (this.fn.backgroundContent != null) {
                let b = this.fn.backgroundContent;
                b.be(this.j.ae);
                b.bd(a);
            }
        }
        dv(a) {
            super.dv(a);
            this.fz = a;
            if (this.fn.backgroundContent != null) {
                let b = this.fn.backgroundContent;
                b.bf(this.fz);
            }
        }
        fy() {
            return new Rect(0, 0, 0, this.fz.width, this.fz.height);
        }
        fs() {
            if (this.fn.backgroundContent != null) {
                let a = this.fn.backgroundContent;
                a.a6();
            }
        }
        fr(a) {
            if (this.fn.w0 != null) {
                this.fn.w0.windowRect = a;
            }
        }
        fu(a, b) {
            if (this.fn.w0 != null) {
                this.fn.w0.windowRect = this.fn.v5;
            }
            if (a != null) {
                let c = a.ao;
                if (c != null) {
                    this.fn.al.h.remove(c.ag);
                }
                a.bd(null);
                a.be(null);
            }
            if (b != null) {
                let d = b.ao;
                if (d != null) {
                    this.fn.al.h.add(d.ag);
                }
                if (!this.fz.isEmpty) {
                    this.dv(this.fz);
                }
                if (this.w != null) {
                    this.du(this.w);
                }
            }
            if (b == null) {
                this.ft(this.w);
            }
        }
        ft(a) {
            let b = this.fn.hj;
            if (b != 1) {
                a.aa();
                a.ab(b, b);
            }
            a.l(this.fz.left, this.fz.top, this.fz.width, this.fz.height);
            if (b != 1) {
                a.z();
            }
        }
        d1() {
            this.fd.ad = Defaults.j;
            this.fe.ad = Defaults.j;
            this.fd._stroke = Defaults.ae;
            this.fe._stroke = Defaults.ae;
            super.d1();
        }
        fv(a) {
            this.fp = a;
            if (this.fn.backgroundContent != null) {
                this.fn.backgroundContent.bc(a);
            }
        }
        get fq() {
            return this.fp;
        }
        set fq(a) {
            this.fp = a;
        }
    }
    XamGeographicMapView.$t = /*@__PURE__*/ markType(XamGeographicMapView, 'XamGeographicMapView', SeriesViewerView.$);
    return XamGeographicMapView;
})();
/**
 * @hidden
 */
export let OpenStreetMapImagery = /*@__PURE__*/ (() => {
    class OpenStreetMapImagery extends GeographicMapImagery {
        constructor() {
            super(new OpenStreetMapTileSource());
        }
        get tilePath() {
            return this.c(OpenStreetMapImagery.tilePathProperty);
        }
        set tilePath(a) {
            this.h(OpenStreetMapImagery.tilePathProperty, a);
        }
        static br(a, b) {
            a.bq("TilePath", b.oldValue, b.newValue);
        }
        bq(a, b, c) {
            switch (a) {
                case "TilePath":
                    this.ap.setTilePathUrl(c == null ? null : c);
                    this.aj.e();
                    break;
            }
            super.ba(a, b, c);
        }
    }
    OpenStreetMapImagery.$t = /*@__PURE__*/ markType(OpenStreetMapImagery, 'OpenStreetMapImagery', GeographicMapImagery.$);
    OpenStreetMapImagery.tilePathProperty = /*@__PURE__*/ DependencyProperty.i("TilePath", String_$type, OpenStreetMapImagery.$, /*@__PURE__*/ new PropertyMetadata(2, null, OpenStreetMapImagery.br));
    return OpenStreetMapImagery;
})();
/**
 * @hidden
 */
export let GeographicXYTriangulatingSeries = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeries extends GeographicMapSeriesHost {
        ct() {
            return new GeographicXYTriangulatingSeriesView(this);
        }
        q1(a) {
            super.q1(a);
            this.xa = a;
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.xa.co();
                    break;
                case GeographicXYTriangulatingSeries.$$p[1]:
                    this.xa.cn();
                    break;
                case GeographicXYTriangulatingSeries.$$p[0]:
                    this.xa.cm();
                    break;
                case GeographicXYTriangulatingSeries.$$p[5]:
                    this.xa.cp();
                    break;
                case GeographicXYTriangulatingSeries.$$p[2]:
                    this.xa.cq();
                    break;
                case GeographicXYTriangulatingSeries.$$p[3]:
                    this.xa.cr();
                    break;
                case GeographicXYTriangulatingSeries.$$p[4]:
                    this.xa.cs();
                    break;
            }
        }
    }
    GeographicXYTriangulatingSeries.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeries, 'GeographicXYTriangulatingSeries', GeographicMapSeriesHost.$);
    GeographicXYTriangulatingSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicXYTriangulatingSeries, 'raisePropertyChanged', ['LatitudeMemberPath:xc:xn', [2, "pointY"], 'LongitudeMemberPath:xe:xo', [2, "pointX"], 'TriangleVertexMemberPath1:xh:xq', [2, "v1"], 'TriangleVertexMemberPath2:xj:xr', [2, "v2"], 'TriangleVertexMemberPath3:xl:xs', [2, "v3"], 'TrianglesSource:xb:xp', [IEnumerable_$type, null]]);
    return GeographicXYTriangulatingSeries;
})();
/**
 * @hidden
 */
export let GeographicScatterAreaSeries = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeries extends GeographicXYTriangulatingSeries {
        bk() {
            return new GeographicScatterAreaSeries();
        }
        get_ev() {
            return true;
        }
        constructor() {
            super();
            this.xt = null;
            this.triangulationStatusChanged = null;
            this.ab = GeographicScatterAreaSeries.$;
        }
        get xv() {
            return this.xt;
        }
        set xv(a) {
            let b = this.xt != a;
            if (b) {
                let c = this.xt;
                if (this.xt != null) {
                    let d = this.xt;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.x3));
                }
                this.xt = a;
                if (this.xt != null) {
                    let e = this.xt;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.x3));
                }
                this.raisePropertyChanged("ColorScale", c, this.xt);
                if (this.xw != null) {
                    this.xw.yx = a;
                }
            }
        }
        x3(a, b) {
            this.xy.cv();
            this.x5();
            this.rs(false);
        }
        x5() {
            if (this.xw != null) {
                this.xu = this.xw.yw;
            }
        }
        sj() {
            super.sj();
            this.x5();
        }
        w1() {
            this.xw = new ScatterAreaSeries();
            let a = this.xw;
            a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.x4));
            return this.xw;
        }
        x4(a, b) {
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, b);
            }
        }
        ct() {
            return new GeographicScatterAreaSeriesView(this);
        }
        q1(a) {
            super.q1(a);
            this.xy = a;
        }
        ra(a, b, c, d) {
            super.ra(a, b, c, d);
            switch (b) {
                case GeographicScatterAreaSeries.$$p[1]:
                    this.xy.cu();
                    break;
                case "ColorScale":
                    this.xy.cv();
                    this.x5();
                    break;
            }
        }
        get_g7() {
            return true;
        }
        set_g7(a) {
            super.set_g7(a);
        }
    }
    GeographicScatterAreaSeries.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeries, 'GeographicScatterAreaSeries', GeographicXYTriangulatingSeries.$);
    GeographicScatterAreaSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:xu:x6', [ColorScale.$, null], 'ColorMemberPath:x0:x7', [2, "value"]]);
    return GeographicScatterAreaSeries;
})();
