import { SeriesViewer } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { DependencyObject } from "igniteui-webcomponents-core";
import { MapResizeBehavior } from "./MapResizeBehavior";
import { MapBackgroundTilingMode } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-webcomponents-core";
import { Base, Point, Type, INotifyPropertyChanged, PropertyChangedEventArgs, IEnumerable } from "igniteui-webcomponents-core";
import { NumericXAxis } from "igniteui-webcomponents-charts";
import { NumericYAxis } from "igniteui-webcomponents-charts";
import { Control } from "igniteui-webcomponents-core";
import { DomRenderer } from "igniteui-webcomponents-core";
import { ScalerParams } from "igniteui-webcomponents-charts";
import { Brush } from "igniteui-webcomponents-core";
import { Series } from "igniteui-webcomponents-charts";
import { SeriesViewerView } from "igniteui-webcomponents-charts";
import { Tuple$2 } from "igniteui-webcomponents-core";
import { ZoomCoercionMode } from "igniteui-webcomponents-charts";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { FontInfo } from "igniteui-webcomponents-core";
import { XamMultiScaleImage } from "igniteui-webcomponents-core";
import { XamMultiScaleTileSource } from "igniteui-webcomponents-core";
import { DownloadingMultiScaleImageEventArgs } from "igniteui-webcomponents-core";
import { CancellingMultiScaleImageEventArgs } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { SeriesView } from "igniteui-webcomponents-charts";
import { ScatterAreaSeries } from "igniteui-webcomponents-charts";
import { InteractionState } from "igniteui-webcomponents-core";
import { ColorScale } from "igniteui-webcomponents-charts";
import { TriangulationStatusEventArgs } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class XamGeographicMap extends SeriesViewer implements IMapRenderDeferralHandler {
    static $t: Type;
    constructor();
    private xk;
    provideContainer(a: any): void;
    n1(): void;
    fk(): boolean;
    fl(): boolean;
    xd: boolean;
    static w5: MapResizeBehavior;
    w6: MapResizeBehavior;
    w9: boolean;
    xa: boolean;
    protected w4(): MapBackgroundTilingMode;
    private w1;
    get w3(): MapBackgroundTilingMode;
    set w3(a: MapBackgroundTilingMode);
    w2: MapBackgroundTilingMode;
    static ys: Rect;
    xg: number;
    xc: boolean;
    xb: boolean;
    y8: Rect;
    private yr;
    get yw(): Rect;
    set yw(a: Rect);
    y0(): Rect;
    private x2;
    private y6;
    get backgroundContent(): GeographicMapImagery;
    set backgroundContent(a: GeographicMapImagery);
    private wy;
    get wv(): NumericXAxis;
    set wv(a: NumericXAxis);
    private wu;
    get wx(): NumericYAxis;
    set wx(a: NumericYAxis);
    private ww;
    w0: GeographicMapImagery;
    private static yv;
    getZoomRectFromGeoRect(a: Rect): Rect;
    yc(a: Rect): void;
    yb(a: Rect): void;
    getZoomFromGeographicRect(a: Rect): Rect;
    yx(a: Rect, b: number): Rect;
    private yy;
    getZoomFromGeographicPoints(a: Point, b: Point): Rect;
    y2(a: Rect): Rect;
    yo(a: Point): Point;
    yp(a: Point): Point;
    yq(a: Point): Point;
    xz(): void;
    x5(a: Brush): void;
    gf(): boolean;
    x7(): void;
    protected yn: Point;
    protected ya(): void;
    protected x6(): void;
    protected get_fc(): boolean;
    protected yu: Rect;
    protected v6(): Rect;
    m5(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    wh(): Rect;
    private yz;
    protected v7(a: Rect): Rect;
    y1(a: Rect): Rect;
    protected c8(): SeriesViewerView;
    private x1;
    protected p6(a: SeriesViewerView): void;
    qh(a: Rect, b: Rect): void;
    xi: number;
    private xf;
    get xh(): number;
    set xh(a: number);
    ht(): number;
    hu(): number;
    protected rl(): void;
    f3(): boolean;
    cs(): ZoomCoercionMode;
    protected qi(a: any, b: string, c: any, d: any): void;
    imageTilesReady: (sender: any, e: ImageTilesReadyEventArgs) => void;
    private x3;
    private x8;
    private x9;
    w7: XamGeographicMapView;
    private w8;
    getFontInfo(): FontInfo;
    u9(): Brush;
    getFontBrush(): Brush;
    protected re(a: Series, b: any): void;
    register(a: DependencyObject, b: (arg1: boolean) => void): void;
    unRegister(a: DependencyObject): void;
    deferredRefresh(): void;
    deferAction(a: () => void): void;
    x0(a: boolean): void;
    xl(): any;
    wd(a: Rect, b: Rect, c: Rect): Rect;
    x4(): void;
    private yt;
    protected get y7(): Rect;
    protected set y7(a: Rect);
    ye(a: Rect): void;
    private yd;
    get xe(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class GeographicMapImagery extends Control implements INotifyPropertyChanged {
    static $t: Type;
    constructor(a: XamMultiScaleTileSource);
    protected bb(a: GeographicMapImageryView): void;
    protected ai(): GeographicMapImageryView;
    protected aj: GeographicMapImageryView;
    private ak;
    get deferralHandler(): IMapRenderDeferralHandler;
    set deferralHandler(a: IMapRenderDeferralHandler);
    private a5;
    a9(): void;
    private a3;
    private a2;
    private bg;
    protected ba(a: string, b: any, c: any): void;
    windowRect: Rect;
    get geographicMap(): XamGeographicMap;
    set geographicMap(a: XamGeographicMap);
    static readonly geographicMapProperty: DependencyProperty;
    private static a8;
    private a7;
    clearTileCache(): void;
    imageTilesReady: (sender: any, e: ImageTilesReadyEventArgs) => void;
    private an;
    get ao(): XamMultiScaleImage;
    set ao(a: XamMultiScaleImage);
    ap: XamMultiScaleTileSource;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    bn(a: Size): Size;
    bd(a: RenderingContext): void;
    bf(a: Rect): void;
    be(a: DomRenderer): void;
    imagesChanged: (sender: any, e: ImagesChangedEventArgs) => void;
    private a4;
    a6(): void;
    bc(a: number): void;
    protected v(): void;
    cancellingImage: (sender: any, args: CancellingMultiScaleImageEventArgs) => void;
    downloadingImage: (sender: any, args: DownloadingMultiScaleImageEventArgs) => void;
    referer: string;
    isHorizontalWrappingEnabled: boolean;
    userAgent: string;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicMapImageryView extends Base {
    static $t: Type;
    constructor(a: GeographicMapImagery);
    protected a: GeographicMapImagery;
    e(): void;
    protected j: Rect;
    f(a: RenderingContext): void;
    private d;
    g(a: DomRenderer): void;
    h(a: Rect): void;
    private b;
    get c(): number;
    i(a: number): void;
}
/**
 * @hidden
 */
export declare class GeographicXYTriangulatingSeriesView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicXYTriangulatingSeries);
    protected cl: GeographicXYTriangulatingSeries;
    b9(): void;
    co(): void;
    cn(): void;
    cm(): void;
    cp(): void;
    cq(): void;
    cr(): void;
    cs(): void;
}
/**
 * @hidden
 */
export declare class GeographicScatterAreaSeriesView extends GeographicXYTriangulatingSeriesView {
    static $t: Type;
    constructor(a: GeographicScatterAreaSeries);
    private ct;
    ax(): void;
    b9(): void;
    cu(): void;
    cv(): void;
}
/**
 * @hidden
 */
export declare class XamGeographicMapView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamGeographicMap);
    m(a: boolean): InteractionState;
    bk(a: boolean): void;
    protected fn: XamGeographicMap;
    protected get_ap(): boolean;
    d4(): void;
    du(a: RenderingContext): void;
    protected fz: Rect;
    protected dv(a: Rect): void;
    fy(): Rect;
    fs(): void;
    fx: Brush;
    fw: Brush;
    fo: FontInfo;
    fr(a: Rect): void;
    fu(a: GeographicMapImagery, b: GeographicMapImagery): void;
    private ft;
    protected d1(): void;
    fv(a: number): void;
    private fp;
    get fq(): number;
    set fq(a: number);
}
/**
 * @hidden
 */
export declare class OpenStreetMapImagery extends GeographicMapImagery {
    static $t: Type;
    constructor();
    get tilePath(): string;
    set tilePath(a: string);
    static readonly tilePathProperty: DependencyProperty;
    private static br;
    private bq;
}
/**
 * @hidden
 */
export declare abstract class GeographicXYTriangulatingSeries extends GeographicMapSeriesHost {
    static $t: Type;
    protected ct(): SeriesView;
    q1(a: SeriesView): void;
    xa: GeographicXYTriangulatingSeriesView;
    xe: string;
    xc: string;
    xb: IEnumerable;
    xh: string;
    xj: string;
    xl: string;
    protected ra(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicScatterAreaSeries extends GeographicXYTriangulatingSeries {
    static $t: Type;
    protected bk(): Series;
    protected get_ev(): boolean;
    constructor();
    x0: string;
    private xt;
    get xv(): ColorScale;
    set xv(a: ColorScale);
    private x3;
    x5(): void;
    xu: ColorScale;
    protected sj(): void;
    xw: ScatterAreaSeries;
    protected w1(): Series;
    private x4;
    protected ct(): SeriesView;
    q1(a: SeriesView): void;
    xy: GeographicScatterAreaSeriesView;
    protected ra(a: any, b: string, c: any, d: any): void;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    protected get_g7(): boolean;
    protected set_g7(a: boolean): void;
    static $$p: string[];
}
